// File to contain all the declares for the castle
// Nazrat Durand 1997 07 08

#declare Color1 = Red
#declare Color2 = White
#declare Color3 = Blue
#declare Color4 = Yellow

#include "Caslayer.inc"


#declare Left_Corner = union {
  object {AngleOne
    translate < 0, 0, -wide*2 >   rotate < 0, 30, 0>
    translate < 0, 0, -wide*52 >
    finish { ambient 1 } pigment { color Cyan } }
  object { AngleThree
    translate < 0, 0, -wide*2 >    rotate < 0, 30, 0>
    translate < 0, tall, -wide*52 >
    finish { ambient 1 } pigment { color Magenta } }
  }

#declare Left_Front_Wall = union {
  object { Long_Layer }                // 20
  object { Short_Layer }               // 19
  object { Left_Corner }               //  2

  rotate < 0, 30, 0>
  translate < 0, 0, -wide*2 >
  rotate < 0, 120, 0>
  translate < -wide*14, 0, wide*2 >
}


#declare Left_Front_Catwalk = union {
  object { Catwalk }
  object { Parapet }
  object { AngleFourRight
    rotate < 0, 90, 0>  translate < -wide*2, tall, -wide*52>
    finish { ambient 1 } pigment { color White }
    }

  object { Left_Corner }
  object { Left_Corner
    translate < 0, tall*2, 0 >
    }
  object { Left_Corner
    translate < 0, tall*4, 0 >
    }

  rotate < 0, 30, 0>                           // swing into position
  translate < 0, 0, -wide*2 >
  rotate < 0, 120, 0>
  translate < -wide*14, tall*8, wide*2 >
}

#declare Left_Rear_Corner = union {
  object { AngleOne
    translate < 0, 0, -wide*2 >   rotate < 0, 30, 0>
    translate < 0, 0, -wide*52 >
    finish { ambient 1 } pigment { Magenta }  }
  object { AngleThree
    translate < 0, 0, -wide*2 >   rotate < 0, 30, 0>
    translate < 0, tall, -wide*52 >
    finish { ambient 1 } pigment { Cyan } }
  }


#declare Left_Rear_Wall = union {
  object { Short_Layer }
  object { Long_Layer }
  object { Left_Rear_Corner }
                                                       // attach to left corner
  rotate < 0, 30, 0>
  translate < 0, 0, -wide*2 >
  rotate < 0, 30, 0>
  translate < 0, 0, -wide*52 >

                                               // swing around with left corner
  rotate < 0, 30, 0>
  translate < 0, 0, -wide*2 >
  rotate < 0, 120, 0>
  translate < -wide*14, 0, wide*2 >
}

#declare Left_Rear_Catwalk = union {
  object { Catwalk }
  object { Parapet }
  object { AngleFourLeft
    rotate < 0, 150, 0>  translate < -wide*2, tall, -wide*52>
    finish { ambient 1 } pigment { color White }
    }

  object { Left_Rear_Corner }
  object { Left_Rear_Corner
    translate < 0, tall*2, 0 >
    }
  object { Left_Rear_Corner
    translate < 0, tall*4, 0 >
    }
                                               // attach to left corner
  rotate < 0, 30, 0>
  translate < 0, 0, -wide*2 >
  rotate < 0, 30, 0>
  translate < 0, 0, -wide*52 >

                                               // swing around with left corner
  rotate < 0, 30, 0>
  translate < 0, 0, -wide*2 >
  rotate < 0, 120, 0>
  translate < -wide*14, tall*8, wide*2 >
}

#declare Right_Corner = union {
  object {AngleOne
    rotate < 0, 150, 0>  translate < wide*2, 0, -wide*52>
    finish { ambient 1 } pigment { color Green } }
  object { AngleThree
    rotate < 0, 150, 0>  translate < wide*2, tall, -wide*52 >
    finish { ambient 1 } pigment { color Tan } }
  }

#declare Right_Front_Wall = union {
  object { Short_Layer }
  object { Long_Layer }
  object { Right_Corner }

  translate < -wide*2, 0, 0 >  rotate < 0, -210, 0 >
  translate < 0, 0, wide*2>    rotate < 0, 60, 0>
  translate < wide*38, 0, wide*2 >
  }


#declare Right_Front_Catwalk = union {
  object { Catwalk
    rotate < 0, 180, 0> translate < wide*2, 0, -wide*52>
    }
  object { Parapet }
  object { Right_Corner }

  object { AngleFourLeft
    rotate < 0, -90, 0>  translate < wide*4, tall, -wide*52>
    finish { ambient 1 } pigment { color White }
    }

  object { Right_Corner
    translate < 0, tall*2, 0 >
    }
  object { Right_Corner
    translate < 0, tall*4, 0 >
    }

  translate < -wide*2, 0, 0 >  rotate < 0, -210, 0 >
  translate < 0, 0, wide*2>    rotate < 0, 60, 0>
  translate < wide*38, tall*8, wide*2 >
  }


#declare Right_Rear_Corner = union {
  object {AngleOne
    rotate < 0, 150, 0>  translate < wide*2, 0, -wide*52>
    finish {ambient 1} pigment { color Tan } }
  object { AngleThree
    rotate < 0, 150, 0>  translate < wide*2, tall, -wide*52 >
    finish {ambient 1} pigment { color Green } }
  }

#declare Right_Rear_Wall = union {
  object { Short_Layer }
  object { Long_Layer }
  object { Right_Rear_Corner }
                                   // attach to right corner>

  translate < -wide*2, 0, 0 >  rotate < 0, 150, 0>
  translate < 0, 0, wide*2 >   rotate < 0, 150, 0>
  translate < wide*2, 0, -wide*52>

                                   // swing around with right corner

  translate < -wide*2, 0, 0 >  rotate < 0, -210, 0 >
  translate < 0, 0, wide*2>    rotate < 0, 60, 0>
  translate < wide*38, 0, wide*2 >
}


#declare Right_Rear_Catwalk = union {
  object { Catwalk
    rotate < 0, 180, 0> translate < wide*2, 0, -wide*52>
  }
  object { Parapet }

  object { AngleFourRight
    rotate < 0, -150, 0>  translate < wide*4, tall, -wide*52>
    finish { ambient 1 } pigment { color White }
    }

  object { Right_Rear_Corner }
  object { Right_Rear_Corner
    translate < 0, tall*2, 0 >
    }
  object { Right_Rear_Corner
    translate < 0, tall*4, 0 >
    }
                                   // attach to right corner>

  translate < -wide*2, 0, 0 >  rotate < 0, 150, 0>
  translate < 0, 0, wide*2 >   rotate < 0, 150, 0>
  translate < wide*2, 0, -wide*52>
                                   // swing around with right corner

  translate < -wide*2, 0, 0 >  rotate < 0, -210, 0 >
  translate < 0, 0, wide*2>    rotate < 0, 60, 0>
  translate < wide*38, tall*8, wide*2 >
  }

#declare Back_Wall = union {
  object { Short_Layer }
  object { Long_Layer }
  rotate < 0, -90, 0 > translate < -wide*14, 0, (sqrt(3)*wide*52) + wide*6>
}


#declare Rear_Catwalk = union {
  object { Catwalk }
  object { Parapet }

  rotate < 0, -90, 0 >
  translate < -wide*14, tall*8, (sqrt(3)*wide*52) + wide*6>
  }
