//  Nazrat Durand, 1998 07 15
//#declare Detail_level=3
#include "ll_commn.inc"
#include "ll_brick.inc"
#include "Angle.inc"

#declare YZ_Mirror = transform {
    matrix < -1, 0, 0,
             0, 1, 0,
             0, 0, 1,
             0, 0, 0 >
    }

///////////////////////////////////////////////////////////////////////
#declare Layer1 = union {
  object { tall2x4
    translate < widr*0, 0, 0 > texture { Colour1}
    }
  object { tall2x4
    translate < widr*4, 0, 0 > texture { Colour2}
    }
  object { tall2x4
    translate < widr*8, 0, 0 > texture { Colour3}
    }
  }
#declare Layer2 = union {
  object { tall2x3
    translate < widr*0, 0, 0 > texture { Colour1}
    }
  object { tall2x3
    translate < widr*3, 0, 0 > texture { Colour2}
    }
  object { tall2x3
    translate < widr*6, 0, 0 > texture { Colour3}
    }
  object { tall2x3
    translate < widr*9, 0, 0 > texture { Colour4}
    }
  }

#declare Layer3 = union {
  object { tall2x3
    translate < widr*0, 0, 0 > texture { Colour1}
    }
  object { tall2x2
    translate < widr*3, 0, 0 > texture { Colour2}
    }
  object { tall2x3
    translate < widr*5, 0, 0 > texture { Colour3}
    }
  object { tall2x4
    translate < widr*8, 0, 0 > texture { Colour4}
    }
  }

#declare Layer4 = union {
  object { tall2x2
    translate < widr*2, 0, 0 > texture { Colour1}
    }
  object { tall2x2
    translate < widr*5, 0, 0 > texture { Colour2}
    }
  object { tall2x2
    translate < widr*8, 0, 0 > texture { Colour3}
    }
  object { tall2x2
    translate < widr*11, 0, 0 > texture { Colour4}
    }
  }
#declare Layer5 = union {
  object { tall2x4
    rotate < 0, 90, 0 > translate < widr*3, 0, widr*4 >
    texture { Colour1 }
    }
  object { tall2x3
    rotate < 0, 90, 0 > translate < widr*5, 0, widr*3 >
    texture { Colour2 }
    }
  object { tall2x4
    rotate < 0, 90, 0 > translate < widr*7, 0, widr*4 >
    texture { Colour3 }
    }
  object { tall2x3
    rotate < 0, 90, 0 > translate < widr*9, 0, widr*3 >
    texture { Colour4 }
    }
  object { tall2x4
    rotate < 0, 90, 0 > translate < widr*11, 0, widr*4 >
    texture { Colour5 }
    }
  }

#declare Layer6 = union {
  object { tall2x4
    rotate < 0, 90, 0 > translate < widr*2, 0, widr*6 >
    texture { Colour1 }
    }
  object { tall2x4
    rotate < 0, 90, 0 > translate < widr*4, 0, widr*6 >
    texture { Colour2 }
    }
  object { tall2x4
    rotate < 0, 90, 0 > translate < widr*6, 0, widr*6 >
    texture { Colour3 }
    }
  object { tall2x4
    rotate < 0, 90, 0 > translate < widr*8, 0, widr*6 >
    texture { Colour4 }
    }
  object { tall2x4
    rotate < 0, 90, 0 > translate < widr*10, 0, widr*6 >
    texture { Colour5 }
    }
  object { tall2x4
    rotate < 0, 90, 0 > translate < widr*12, 0, widr*6 >
    texture { Colour6 }
    }
  }
///////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////// A Section

#declare Wall_Section1 = union {

  #if ( this_frame >= 1 )
    object { Layer1
      translate < 0, 0, 0 > }
    #end
  #if ( this_frame >= 2 )
    object { Layer1
      translate < widr*2, talr*1, 0 > }
    #end
  #if ( this_frame >= 3 )
    object { Layer1
      translate < 0, talr*2, 0 > }
    #end
  #if ( this_frame >= 4 )
    object { Layer3
      translate < widr*2, talr*3, 0 > }
    #end
  #if ( this_frame >= 5 )
    object { Layer2
      translate < 0, talr*4, 0 > }
    #end
  #if ( this_frame >= 6 )
    object { Layer2
      translate < widr*2, talr*5, 0 > }
    #end
  #if ( this_frame >= 7 )
    object { Layer2
      translate < 0, talr*6, 0 > }
    #end
  #if ( this_frame >= 8 )
    object { Layer3
      translate < widr*2, talr*7, 0 > }
    #end
  #if ( this_frame >= 9 )
    object { Layer1
      translate < 0, talr*8, 0 > }
    #end
  #if ( this_frame >= 10 )
    object { Layer1
      translate < widr*2, talr*9, 0 > }
    #end
  #if ( this_frame >= 11 )
    object { Layer5
      translate < 0, talr*10, 0 > }
    #end
  #if ( this_frame >= 12 )
    object { Layer6
      translate < 0, talr*11, 0 > }
    object { Layer1
      translate < widr*2, talr*11, 0 > }
    #end
  #if ( this_frame >= 13 )
    object { Layer1
      translate < 0, talr*12, 0 > }
    #end
  #if ( this_frame >= 14 )
    object { Layer3
      translate < widr*2, talr*13, 0 > }
    #end
  #if ( this_frame >= 15 )
    object { Layer2
      translate < 0, talr*14, 0 > }
    #end
  #if ( this_frame >= 16 )
    object { Layer4
      translate < 0, talr*15, 0 > }
    #end
  }

#declare Wall_Section2 = object { Wall_Section1
    transform YZ_Mirror
    }

///////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////// The Tower


#declare The_Curtain = union {
  #if ( this_frame >= 11 )
    object { tall2x3
      translate < 0, talr*10, 0 > texture { Colour2 }
      }
    #end

  object { Wall_Section1 }

  #if ( this_frame >= 1 )
    object { tall2x4
      translate < widr*12, talr*0, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 3 )
    object { tall2x4
      translate < widr*12, talr*2, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 5 )
    object { tall2x4
      translate < widr*12, talr*4, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 7 )
    object { tall2x4
      translate < widr*12, talr*6, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 9 )
    object { tall2x4
      translate < widr*12, talr*8, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 11 )
    object { tall2x4
      rotate < 0, 90, 0 > translate < widr*13, talr*10, widr*4 >
      texture { Colour6 }
      }
    #end
  #if ( this_frame >= 13 )
    object { tall2x4
      translate < widr*12, talr*12, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 15 )
    object { tall2x4
      translate < widr*12, talr*14, 0 > texture { Colour5 }
      }
    #end

  object { Wall_Section2
    translate < widr*28, 0, 0 >
    }

  #if ( this_frame >= 2 )
    object { tall2x4
      translate < widr*26, talr*1, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 4 )
    object { tall2x4
      translate < widr*26, talr*3, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 6 )
    object { tall2x4
      translate < widr*26, talr*5, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 8 )
    object { tall2x4
      translate < widr*26, talr*7, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 10 )
    object { tall2x4
      translate < widr*26, talr*9, 0 > texture { Colour5 }
      }
      #end
  #if ( this_frame >= 11 )
    object { tall2x3
      rotate < 0, 90, 0 > translate < widr*25, talr*10, widr*3 >
      texture { Colour6 }
      }
    object { tall2x4
      rotate < 0, 90, 0 > translate < widr*27, talr*10, widr*4 >
      texture { Colour5 }
      }
    object { tall2x3
      rotate < 0, 90, 0 > translate < widr*29, talr*10, widr*3 >
      texture { Colour6 }
      }
    #end
  #if ( this_frame >= 12 )
    object { tall2x4
      translate < widr*26, talr*11, 0 > texture { Colour5 }
      }
    object { tall2x4
      rotate < 0, 90, 0 > translate < widr*26, talr*11, widr*6 >
      texture { Colour5 }
      }
    object { tall2x4
      rotate < 0, 90, 0 > translate < widr*28, talr*11, widr*6 >
      texture { Colour6 }
      }
    #end
  #if ( this_frame >= 14 )
    object { tall2x4
      translate < widr*26, talr*13, 0 > texture { Colour5 }
      }
    #end

  object { Wall_Section1
    translate < widr*28, 0, 0 >
    }

  #if ( this_frame >= 1 )
    object { tall2x4
      translate < widr*40, talr*0, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 2 )
    object { tall2x4
      translate < widr*42, talr*1, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 3 )
    object { tall2x4
      translate < widr*40, talr*2, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 4 )
    object { tall2x4
      translate < widr*42, talr*3, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 5 )
    object { tall2x4
      translate < widr*40, talr*4, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 6 )
    object { tall2x4
      translate < widr*42, talr*5, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 7 )
    object { tall2x4
      translate < widr*40, talr*6, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 8 )
    object { tall2x4
      translate < widr*42, talr*7, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 9 )
    object { tall2x4
      translate < widr*40, talr*8, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 10 )
    object { tall2x4
      translate < widr*42, talr*9, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 11 )
    object { tall2x3
      rotate < 0, 90, 0 > translate < widr*41, talr*10, widr*3 >
      texture { Colour6 }
      }
    object { tall2x4
      rotate < 0, 90, 0 > translate < widr*43, talr*10, widr*4 >
      texture { Colour5 }
      }
    #end
  #if ( this_frame >= 12 )
    object { tall2x4
      translate < widr*42, talr*11, 0 > texture { Colour5 }
      }
    object { tall2x4
      rotate < 0, 90, 0 > translate < widr*40, talr*11, widr*6 >
      texture { Colour6 }
      }
    object { tall2x4
      rotate < 0, 90, 0 > translate < widr*42, talr*11, widr*6 >
      texture { Colour5 }
      }
    object { tall2x4
      rotate < 0, 90, 0 > translate < widr*44, talr*11, widr*6 >
      texture { Colour5 }
      }
    #end
  #if ( this_frame >= 13 )
    object { tall2x4
      translate < widr*40, talr*12, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 14 )
    object { tall2x4
      translate < widr*42, talr*13, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 15 )
    object { tall2x4
      translate < widr*40, talr*14, 0 > texture { Colour5 }
      }
    #end
  #if ( this_frame >= 16 )
    object { tall2x2
      translate < widr*43, talr*15, 0 > texture { Colour6 }
      }
    #end
}

#declare The_Wall = union {

  object { The_Curtain }

  #if ( this_frame >= 1 )
    object { tall2x4
      translate < widr*44, talr*0, 0 > texture { Colour6 }
      }
    #end
  #if ( this_frame >= 3 )
    object { tall2x4
      translate < widr*44, talr*2, 0 > texture { Colour6 }
      }
    #end
  #if ( this_frame >= 5 )
    object { tall2x4
      translate < widr*44, talr*4, 0 > texture { Colour6 }
      }
    #end
  #if ( this_frame >= 7 )
    object { tall2x4
      translate < widr*44, talr*6, 0 > texture { Colour6 }
      }
    #end
  #if ( this_frame >= 9 )
    object { tall2x4
      translate < widr*44, talr*8, 0 > texture { Colour6 }
      }
    #end
  #if ( this_frame >= 11 )
    object { tall2x3
      rotate < 0, 90, 0 > translate < widr*45, talr*10, widr*3 >
      texture { Colour6 }
      }
    #end
  #if ( this_frame >= 13 )
    object { tall2x4
      translate < widr*44, talr*12, 0 > texture { Colour6 }
      }
    #end
  #if ( this_frame >= 15 )
    object { tall2x4
      translate < widr*44, talr*14, 0 > texture { Colour6 }
      }
    #end

  object { The_Curtain
    transform YZ_Mirror
    translate < widr*92, 0, 0 >
    }
/*
  cylinder {
    < widr*46, 0.2, 0 >
    < widr*46, 0.2, widr*112 >
    widr*0.5
    pigment { color Green }
    }
*/
  }

/////////////////////////////////////////////////////// END OF THE WALL
///////////////////////////////////////////////////////////////////////
